controllers/AutoresController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Autores;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * AutoresController implements the CRUD actions for Autores model.
 */
class AutoresController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Autores models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Autores::find(),
            'pagination'=>[
                'pageSize'=>5,
            ],
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Autores model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Autores model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Autores();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_autor]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Autores model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_autor]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Autores model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Autores model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Autores the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Autores::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/LibrosController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Libros;
use app\models\LibrosSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LibrosController implements the CRUD actions for Libros model.
 */
class LibrosController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Libros models.
     * @return mixed
     */
    public function actionIndex(){
        $consulta= Yii::$app->db->createCommand("SELECT DISTINCT libros.*,editorial FROM libros JOIN escriben USING (id_libro)
        JOIN autores USING (id_autor)
        JOIN editoriales USING (id_editorial);")
                ->queryAll();
        return $this->render('index',['datos'=>$consulta]);

    }
    
   
    
    
    public function actionBuscar()
    {
        $searchModel = new LibrosSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Libros model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        $model=$this->findModel($id);
        $leido=($model->leido==0)?"No":"Si";
        $coleccion=($model->id_coleccion==null)?"No tiene Colección":$model->id_coleccion;
        $autores= Yii::$app->db->createCommand("SELECT autor from autores JOIN escriben USING(id_autor) WHERE id_libro=$model->id_libro")->queryAll();
        $autor="";
        foreach($autores as $valor){
            $autor.= $valor["autor"]."  ";
        }
        $editorial= (new \yii\db\Query())
                ->select('editorial')
                ->from('editoriales')
                ->join('INNER JOIN', 'libros', 'editoriales.id_editorial=libros.id_editorial')
                ->where("id_libro=$id")
                ->one();
        
        return $this->render('view', [
            'model' =>$model,
            'leido'=>$leido,
            'coleccion'=>$coleccion,
            'autor'=>$autor,
            'editorial'=>$editorial["editorial"],
        ]);
    }

    /**
     * Creates a new Libros model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Libros();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_libro]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Libros model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_libro]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Libros model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Libros model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Libros the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Libros::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    
    public function actionIndex()
    {
        return $this->render('index');
    }

   
    public function actionBusqueda(){
        //if($_POST["busqueda"]!=""){
        $cadena=$_POST["busqueda"];
       
  
        $datos= \Yii::$app->db->createCommand(
            'SELECT * FROM libros JOIN escriben USING (id_libro)
            JOIN autores USING (id_autor)
            JOIN editoriales USING (id_editorial)
            JOIN reproducen USING (id_libro)
            JOIN tematicas USING (id_tematica)
            WHERE titulo LIKE "%'.$cadena.'%" or tematica LIKE "%'.$cadena.'%" OR autor LIKE "%'.$cadena.'%" OR editorial LIKE "%'.$cadena.'%"
            GROUP BY libros.id_libro')->queryAll();
    
        return $this->render('busqueda',['datos'=>$datos]);
        //}else{
          //return $this->render('error',['name'=>"Error",'message'=>'No has introducido ningún patrón de búsqueda']);
       // }
    }
    
    public function actionBusquedaajax(){
        
        $cadena=\Yii::$app->request->post("texto");
        $consulta= \Yii::$app->db->createCommand('SELECT * FROM libros JOIN escriben USING (id_libro)
            JOIN autores USING (id_autor)
            JOIN editoriales USING (id_editorial)
            JOIN reproducen USING (id_libro)
            JOIN tematicas USING (id_tematica)
            WHERE titulo LIKE "%'.$cadena.'%" or tematica LIKE "%'.$cadena.'%" OR autor LIKE "%'.$cadena.'%" OR editorial LIKE "%'.$cadena.'%"
            GROUP BY libros.id_libro')->queryAll();
            
            $obj=["titulo"=>[],
                   "autor"=>[],
                   "editorial"=>[],
                ];        
            foreach($consulta as $dato){
                $obj["titulo"][]=$dato["titulo"];
                $obj["autor"][]=$dato["autor"];
                $obj["editorial"][]=$dato["editorial"];
            }
            echo json_encode($obj);
        
        
        //return $this->renderAjax('busqueda');
    
    }
    
    
    
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

  
}

controllers/TematicasController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Tematicas;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * TematicasController implements the CRUD actions for Tematicas model.
 */
class TematicasController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Tematicas models.
     * @return mixed
     */
    public function actionIndex()
    {
       
        $modelo= Tematicas::find()->where(['id_padre'=>1])->all();
            
        return $this->render('index', [
            'modelo' => $modelo,
        ]);
    }
    
    public function actionMuestralibros($id){
        $modelo= Tematicas::find()->where(['id_padre'=>1])->all();
        $consulta= Tematicas::find()->where(['id_tematica'=>$id])->all();
        foreach($consulta as $valor){
            $libros=$valor->getLibros()->all();
        }
              
        return $this->render('index', [
            'modelo' => $modelo,'libros'=>$libros,'id_pulsada'=>$id
        ]);
        
    }
    
    public function actionIndex2(){
        $modelo= Tematicas::find()->where(['id_padre'=>1])->all();
  
        return $this->render('index2',['datos'=>$modelo]);
    }
    
    public function actionLibrosgenerales(){
        $id = $_POST['id'];
        $consulta= Tematicas::find()->where(['id_tematica'=>$id])->all();
        foreach($consulta as $reg){
            $libros=$reg->getLibros()->all();
            foreach($libros as $libro){
                echo "<br>". \yii\helpers\Html::a($libro->titulo,['libros/view','id'=>$libro->id_libro])."<br>";
            }
        }
    }

    /**
     * Displays a single Tematicas model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Tematicas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Tematicas();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_tematica]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Tematicas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_tematica]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Tematicas model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Tematicas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Tematicas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Tematicas::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\widgets\Alert;
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\widgets\Breadcrumbs;
use app\assets\AppAsset;
use yii\widgets\ActiveForm;

AppAsset::register($this);

$home=Yii::$app->homeUrl;
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css" integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU" crossorigin="anonymous">
    <?= Html::csrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
<?php $this->beginBody() ?>

<div class="wrap">
    <?php
    NavBar::begin([
        'brandLabel' =>Html::encode(Yii::$app->name)." ".Html::tag('i',"",['class'=>"fas fa-book-reader"]),
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar-default navbar-fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav navbar-left nav-pills'],
        'items' => [
            ['label' =>'Inicio <span class="glyphicon glyphicon-home"></span>', 'url' => ['/site/index']],
            ['label' => 'Libros <i class="fas fa-book"></i>', 'url' => ['/libros/index']],
            ['label' => 'Autores <i class="fas fa-user-edit"></i>', 'url' => ['/autores/index']],
            ['label' => 'Editoriales <i class="fas fa-landmark"></i>', 'url' => ['/editoriales/index']],
            ['label' => 'Temáticas <i class="fas fa-theater-masks"></i>',
                'items'=>[
                    ['label' => 'Temáticas generales', 'url' => ['/tematicas/index2']],
                    ['label' => 'Tématicas y subtemáticas', 'url' => ['/tematicas/index']],
                ],
            ],
        ],
        'encodeLabels' => false,
    ]);
    echo Html::beginForm(["site/busqueda"],"post",["class"=>"navbar-form navbar-right","id"=>"form1"]);
            echo '<div class="form-group">';
            echo  '<input id="texto1" type="text" class="form-control buscar" placeholder="&#xF002;" name="busqueda" onkeyup="comprueba(this)" />';
            echo  '<button type="submit" class="btn btn-default">Buscar</button>';
            echo  '</div>';
            echo Html::endForm();
    NavBar::end();
    ?>

    <div class="container principal">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</div>

<footer class="footer">
    <div class="container">
        <p class="pull-left">Alberto Ceballos <?= date('Y') ?></p>

        <p class="pull-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>
<script type="text/javascript">
    function comprueba(e){
        texto=$(e).val();
        //console.log(texto);
        $.ajax({
           url:'busquedaajax',
           type:'post',
           data:{texto:texto},
           success:function(data){
              datos=JSON.parse(data);
              console.log(datos);
              $("#resultados").html("");
              for(i=0;i<datos.titulo.length;i++){
              document.querySelector("#resultados").innerHTML+=('<div class="panel panel-primary"><div class="panel-heading">'+datos.titulo[i]+'</div><div class="panel-body">'+datos.autor[i]+'<br>'+datos.editorial[i]+'</div></div>');   
            }
           }
                   
        });
    }
    
    
</script>